/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

/*
 * @(#) $Id: CacheFilter.java 2089 2007-11-28 13:56:13Z s3460 $
 *
 * 
 * 
 * 
 *
 */
package at.spardat.xma.datasource;

import java.util.Iterator;

import at.spardat.enterprise.cache.ICache;


/**
 * Local class to filter the entries in a cache.
 *
 * XMA open source:
 * This class is copied from
 * at.spardat.enterprise.dom.CacheFilter
 * but it uses TableSpec instead of at.spardat.enterprise.dom.DomTableSpec
 */
public class CacheFilter implements ICache.IKeyFilter {
    private TableSpec        delSpec_;

    public CacheFilter (TableSpec delSpec) {
        delSpec_ = delSpec;
    }

    public CacheFilter (String delSpec) {
        this(new TableSpec(delSpec));
    }

    /**
     * @see at.spardat.enterprise.cache.ICache.IKeyFilter#accept(java.lang.Object)
     */
    public boolean accept (Object key) {
        TableSpec            keySpec = new TableSpec ((String)key);
        // check, if every property in delSpec_ is contained in keySpec
        Iterator                propIter = delSpec_.iterator();
        while (propIter.hasNext()) {
            String delPropKey = (String) propIter.next();
            String delPropValue = delSpec_.getProperty(delPropKey);
            String cacheValue = keySpec.getProperty (delPropKey);
            if (cacheValue == null) return false;
            if (!cacheValue.equals (delPropValue)) return false;
        }
        return true;
    }
}
