/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

package at.spardat.xma.page;

import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;

/**
 * Base class of all Pages shown as one step inside an Assistent.
 * This class is not fully implemented yet.
 *
 * @author s2877
 * @deprecated use XMAWzardPage in GUI designer instead
 */
public abstract class AssistentPage extends PageClient {

    /**
     * Initializes the AssistentPage inside the given Assistent.
     *
     * @param parent the Assistent containing this AssistentPage.
     */
    public AssistentPage(Assistent parent,boolean stateless) {
    	super(parent,stateless);
    }

    /**
     * Creates the Composite and Widgets of the AssistentPage
     * by calling {@link #createWidgets()}.
     */
    public void initGUI() {
    	composite = new Composite(parent.getComposite(), SWT.NONE);
    	composite.setData(this);
        if(!hasModels()) {
            createModels();
        }
    	super.initGUI();
        if(!isUIAttached()) {
            attachUI();
        }
    }

    /**
     * Gets the Assistent containing this AssisentPage.
     *
     * @return the Assistent containing this AssisentPage.
     */
    public Assistent getAssistent() { return (Assistent) parent; }

    /**
     * Decide which WizardPage should be shown after the user pressed
     * the Next-Button. This method can be overwritten for dynamically
     * choosing the next WizardPage. The default implentation returns
     * null and the Wizard chooses the next WizardPage from its internal
     * list.
     *
     * @return null
     */
    protected AssistentPage getNextPage() { return null; }

    /**
     * Decide which WizardPage should be shown after the user pressed
     * the Prev-Button. This method can be overwritten for dynamically
     * choosing the next WizardPage. The default implentation returns
     * null and the Wizard chooses the preceding WizardPage from its internal
     * list.
     *
     * @return null
     */
    protected AssistentPage getPrevPage() { return null; }

}
